#include "adc.h"
#include "delay.h"		 

//20140507 	V1.1
//1,޸Adc_Init,֧ڲ¶ȴݲɼ.
//2,Get_Temprate,ڻȡڲ¶ȴɼ¶ֵ
////////////////////////////////////////////////////////////////////////////////// 
 
//ʼADC
//ǽԹͨΪ
//ǿADC1_CH5ڲ¶ȴͨ(CH16)																   
void  Adc_Init(void)
{    
	//ȳʼIO
 	RCC->APB2ENR|=1<<8;    	//ʹADC1ʱ 
	RCC->AHB1ENR|=1<<0;    	//ʹPORTAʱ	  
	GPIO_Set(GPIOA,PIN5,GPIO_MODE_AIN,0,0,GPIO_PUPD_PU);	//PA5,ģ,   

	RCC->APB2RSTR|=1<<8;   	//ADCsλ
	RCC->APB2RSTR&=~(1<<8);	//λ	 
	ADC->CCR=1<<16;			//ADCCLK=PCLK2/4=84/4=21Mhz,ADCʱòҪ36Mhz
 	ADC->CCR|=1<<23;		//ʹڲ¶ȴ
	
	ADC1->CR1=0;   			//CR1
	ADC1->CR2=0;   			//CR2
	ADC1->CR1|=0<<24;      	//12λģʽ
	ADC1->CR1|=0<<8;    	//ɨģʽ	
	
	ADC1->CR2&=~(1<<1);    	//תģʽ
 	ADC1->CR2&=~(1<<11);   	//Ҷ	
	ADC1->CR2|=0<<28;    	//
	
	ADC1->SQR1&=~(0XF<<20);
	ADC1->SQR1|=0<<20;     	//1תڹ Ҳֻת1 			   
	//ͨ5Ĳʱ
	ADC1->SMPR2&=~(7<<(3*5));		//ͨ5ʱ	  
 	ADC1->SMPR2|=7<<(3*5); 			//ͨ5  480,߲ʱ߾ȷ	
	
	
	ADC1->SMPR1&=~(7<<(3*(16-10))); //ͨ16ԭ	 
	ADC1->SMPR1|=7<<(3*(16-10));   	//ͨ16 480,߲ʱ߾ȷ
	
 	ADC1->CR2|=1<<0;	   	//ADת	  
}					  
//ADCֵ
//ch:ֵͨ 0~16
//ֵ:ת
u16 Get_Adc(u8 ch)   
{
	//ת	  		 
	ADC1->SQR3&=0XFFFFFFE0;//1 ͨch
	ADC1->SQR3|=ch;		  			    
	ADC1->CR2|=1<<30;       //תͨ 
	while(!(ADC1->SR&1<<1));//ȴת	 	   
	return ADC1->DR;		//adcֵ	
}
//ȡͨchתֵȡtimes,Ȼƽ 
//ch:ͨ
//times:ȡ
//ֵ:ͨchtimesתƽֵ
u16 Get_Adc_Average(u8 ch,u8 times)
{
	u32 temp_val=0;
	u8 t;
	for(t=0;t<times;t++)
	{
		temp_val+=Get_Adc(ch);
		delay_ms(5);
	}
	return temp_val/times;
}  
//õ¶ֵ
//ֵ:¶ֵ(100,λ:.)
short Get_Temprate(void)
{
	u32 adcx;
	short result;
 	double temperate;
	adcx=Get_Adc_Average(ADC_CH_TEMP,20);	//ȡͨ16,20ȡƽ
	temperate=(float)adcx*(3.3/4096);		//ѹֵ
	temperate=(temperate-0.76)/0.0025+25; 	//תΪ¶ֵ 
	result=temperate*=100;					//100.
	return result;
}









