#include "sys.h"  


//ƫƵַ
//NVIC_VectTab:ַ
//Offset:ƫ		 
void MY_NVIC_SetVectorTable(u32 NVIC_VectTab,u32 Offset)	 
{ 	   	  
	SCB->VTOR=NVIC_VectTab|(Offset&(u32)0xFFFFFE00);//NVICƫƼĴ,VTOR9λ,[8:0]
}
//NVIC
//NVIC_Group:NVIC 0~4 ܹ5 		   
void MY_NVIC_PriorityGroupConfig(u8 NVIC_Group)	 
{ 
	u32 temp,temp1;	  
	temp1=(~NVIC_Group)&0x07;//ȡλ
	temp1<<=8;
	temp=SCB->AIRCR;  //ȡǰ
	temp&=0X0000F8FF; //ǰ
	temp|=0X05FA0000; //дԿ
	temp|=temp1;	   
	SCB->AIRCR=temp;  //÷	    	  				   
}
//NVIC 
//NVIC_PreemptionPriority:ռȼ
//NVIC_SubPriority       :Ӧȼ
//NVIC_Channel           :жϱ
//NVIC_Group             :жϷ 0~4
//עȼܳ趨ķΧ!벻Ĵ
//黮:
//0:0λռȼ,4λӦȼ
//1:1λռȼ,3λӦȼ
//2:2λռȼ,2λӦȼ
//3:3λռȼ,1λӦȼ
//4:4λռȼ,0λӦȼ
//NVIC_SubPriorityNVIC_PreemptionPriorityԭ,ֵԽС,Խ	   
void MY_NVIC_Init(u8 NVIC_PreemptionPriority,u8 NVIC_SubPriority,u8 NVIC_Channel,u8 NVIC_Group)	 
{ 
	u32 temp;	  
	MY_NVIC_PriorityGroupConfig(NVIC_Group);//÷
	temp=NVIC_PreemptionPriority<<(4-NVIC_Group);	  
	temp|=NVIC_SubPriority&(0x0f>>NVIC_Group);
	temp&=0xf;								//ȡλ
	NVIC->ISER[NVIC_Channel/32]|=1<<NVIC_Channel%32;//ʹжλ(ҪĻ,ICERӦλΪ1)
	NVIC->IP[NVIC_Channel]|=temp<<4;				//Ӧȼȼ   	    	  				   
} 
//ⲿжú
//ֻGPIOA~I;PVD,RTC,USB_OTG,USB_HS,̫ѵ
//:
//GPIOx:0~8,GPIOA~I
//BITx:Ҫʹܵλ;
//TRIM:ģʽ,1,;2,Ͻ;3ƽ
//úһֻ1IO,IO,ε
//úԶӦж,Լ   	    
void Ex_NVIC_Config(u8 GPIOx,u8 BITx,u8 TRIM) 
{ 
	u8 EXTOFFSET=(BITx%4)*4;  
	RCC->APB2ENR|=1<<14;  						//ʹSYSCFGʱ  
	SYSCFG->EXTICR[BITx/4]&=~(0x000F<<EXTOFFSET);//ԭã
	SYSCFG->EXTICR[BITx/4]|=GPIOx<<EXTOFFSET;	//EXTI.BITxӳ䵽GPIOx.BITx 
	//Զ
	EXTI->IMR|=1<<BITx;					//line BITxϵж(Ҫֹжϣ򷴲)
	if(TRIM&0x01)EXTI->FTSR|=1<<BITx;	//line BITx¼½ش
	if(TRIM&0x02)EXTI->RTSR|=1<<BITx;	//line BITx¼ش
} 	
//GPIO
//GPIOx:GPIOA~GPIOI.
//BITx:0~15,IOű.
//AFx:0~15,AF0~AF15.
//AF0~15(гõ,ϸ407ֲ,56ҳTable 7):
//AF0:MCO/SWD/SWCLK/RTC   AF1:TIM1/TIM2;            AF2:TIM3~5;               AF3:TIM8~11
//AF4:I2C1~I2C3;          AF5:SPI1/SPI2;            AF6:SPI3;                 AF7:USART1~3;
//AF8:USART4~6;           AF9;CAN1/CAN2/TIM12~14    AF10:USB_OTG/USB_HS       AF11:ETH
//AF12:FSMC/SDIO/OTG/HS   AF13:DCIM                 AF14:                     AF15:EVENTOUT
void GPIO_AF_Set(GPIO_TypeDef* GPIOx,u8 BITx,u8 AFx)
{  
	GPIOx->AFR[BITx>>3]&=~(0X0F<<((BITx&0X07)*4));
	GPIOx->AFR[BITx>>3]|=(u32)AFx<<((BITx&0X07)*4);
}   
//GPIOͨ 
//GPIOx:GPIOA~GPIOI.
//BITx:0X0000~0XFFFF,λ,ÿλһIO,0λPx0,1λPx1,.0X0101,ͬʱPx0Px8.
//MODE:0~3;ģʽѡ,0,(ϵͳλĬ״̬);1,ͨ;2,ù;3,ģ.
//OTYPE:0/1;ѡ,0,;1,©.
//OSPEED:0~3;ٶ,0,2Mhz;1,25Mhz;2,50Mhz;3,100Mh. 
//PUPD:0~3:,0,;1,;2,;3,.
//ע:ģʽ(ͨ/ģ),OTYPEOSPEEDЧ!!
void GPIO_Set(GPIO_TypeDef* GPIOx,u32 BITx,u32 MODE,u32 OTYPE,u32 OSPEED,u32 PUPD)
{  
	u32 pinpos=0,pos=0,curpin=0;
	for(pinpos=0;pinpos<16;pinpos++)
	{
		pos=1<<pinpos;	//һλ 
		curpin=BITx&pos;//ǷҪ
		if(curpin==pos)	//Ҫ
		{
			GPIOx->MODER&=~(3<<(pinpos*2));	//ԭ
			GPIOx->MODER|=MODE<<(pinpos*2);	//µģʽ 
			if((MODE==0X01)||(MODE==0X02))	//ģʽ/ùģʽ
			{  
				GPIOx->OSPEEDR&=~(3<<(pinpos*2));	//ԭ
				GPIOx->OSPEEDR|=(OSPEED<<(pinpos*2));//µٶֵ  
				GPIOx->OTYPER&=~(1<<pinpos) ;		//ԭ
				GPIOx->OTYPER|=OTYPE<<pinpos;		//µģʽ
			}  
			GPIOx->PUPDR&=~(3<<(pinpos*2));	//ԭ
			GPIOx->PUPDR|=PUPD<<(pinpos*2);	//µ
		}
	}
} 

//THUMBָֻ֧
//·ʵִлָWFI  
__asm void WFI_SET(void)
{
	WFI;		  
}
//رж(ǲfaultNMIж)
__asm void INTX_DISABLE(void)
{
	CPSID   I
	BX      LR	  
}
//ж
__asm void INTX_ENABLE(void)
{
	CPSIE   I
	BX      LR  
}
//ջַ
//addr:ջַ
__asm void MSR_MSP(u32 addr) 
{
	MSR MSP, r0 			//set Main Stack value
	BX r14
}
//ģʽ	  
void Sys_Standby(void)
{ 
	SCB->SCR|=1<<2;		//ʹSLEEPDEEPλ (SYS->CTRL)	   
	RCC->APB1ENR|=1<<28;//ʹܵԴʱ 
	PWR->CSR|=1<<8;     //WKUPڻ
	PWR->CR|=1<<2;      //Wake-up ־
	PWR->CR|=1<<1;      //PDDSλ   	
	WFI_SET();			//ִWFIָ,ģʽ		 
}	     
//ϵͳλ   
void Sys_Soft_Reset(void)
{   
	SCB->AIRCR =0X05FA0000|(u32)0x04;	  
} 		 
//ʱú
//Fvco=Fs*(plln/pllm);
//Fsys=Fvco/pllp=Fs*(plln/(pllm*pllp));
//Fusb=Fvco/pllq=Fs*(plln/(pllm*pllq));

//Fvco:VCOƵ
//Fsys:ϵͳʱƵ
//Fusb:USB,SDIO,RNGȵʱƵ
//Fs:PLLʱƵ,HSI,HSE. 
//plln:PLLƵϵ(PLLƵ),ȡֵΧ:64~432.
//pllm:PLLƵPLLƵϵ(PLL֮ǰķƵ),ȡֵΧ:2~63.
//pllp:ϵͳʱӵPLLƵϵ(PLL֮ķƵ),ȡֵΧ:2,4,6,8.(4ֵ!)
//pllq:USB/SDIO/ȵPLLƵϵ(PLL֮ķƵ),ȡֵΧ:2~15.

//ⲿΪ8Mʱ,Ƽֵ:plln=336,pllm=8,pllp=2,pllq=7.
//õ:Fvco=8*(336/8)=336Mhz
//     Fsys=336/2=168Mhz
//     Fusb=336/7=48Mhz
//ֵ:0,ɹ;1,ʧܡ
u8 Sys_Clock_Set(u32 plln,u32 pllm,u32 pllp,u32 pllq)
{ 
	u16 retry=0;
	u8 status=0;
	RCC->CR|=1<<16;				//HSE  
	while(((RCC->CR&(1<<17))==0)&&(retry<0X1FFF))retry++;//ȴHSE RDY
	if(retry==0X1FFF)status=1;	//HSE޷
	else   
	{
		RCC->APB1ENR|=1<<28;	//Դӿʱʹ
		PWR->CR|=3<<14; 		//ģʽ,ʱӿɵ168Mhz
		RCC->CFGR|=(0<<4)|(5<<10)|(4<<13);//HCLK Ƶ;APB1 4Ƶ;APB2 2Ƶ. 
		RCC->CR&=~(1<<24);	//رPLL
		RCC->PLLCFGR=pllm|(plln<<6)|(((pllp>>1)-1)<<16)|(pllq<<24)|(1<<22);//PLL,PLLʱԴHSE
		RCC->CR|=1<<24;			//PLL
		while((RCC->CR&(1<<25))==0);//ȴPLL׼ 
		FLASH->ACR|=1<<8;		//ָԤȡʹ.
		FLASH->ACR|=1<<9;		//ָcacheʹ.
		FLASH->ACR|=1<<10;		//cacheʹ.
		FLASH->ACR|=5<<0;		//5CPUȴ. 
		RCC->CFGR&=~(3<<0);		//
		RCC->CFGR|=2<<0;		//ѡPLLΪϵͳʱ	 
		while((RCC->CFGR&(3<<2))!=(2<<2));//ȴPLLΪϵͳʱӳɹ. 
	} 
	return status;
}  

//ϵͳʱӳʼ
//plln:PLLƵϵ(PLLƵ),ȡֵΧ:64~432.
//pllm:PLLƵPLLƵϵ(PLL֮ǰķƵ),ȡֵΧ:2~63.
//pllp:ϵͳʱӵPLLƵϵ(PLL֮ķƵ),ȡֵΧ:2,4,6,8.(4ֵ!)
//pllq:USB/SDIO/ȵPLLƵϵ(PLL֮ķƵ),ȡֵΧ:2~15.
void Stm32_Clock_Init(u32 plln,u32 pllm,u32 pllp,u32 pllq)
{  
	RCC->CR|=0x00000001;		//HISON,ڲRC
	RCC->CFGR=0x00000000;		//CFGR 
	RCC->CR&=0xFEF6FFFF;		//HSEON,CSSON,PLLON 
	RCC->PLLCFGR=0x24003010;	//PLLCFGRָλֵ 
	RCC->CR&=~(1<<18);			//HSEBYP,ⲿ·
	RCC->CIR=0x00000000;		//ֹRCCʱж 
	Sys_Clock_Set(plln,pllm,pllp,pllq);//ʱ 
	//				  
#ifdef  VECT_TAB_RAM
	MY_NVIC_SetVectorTable(1<<29,0x0);
#else   
	MY_NVIC_SetVectorTable(0,0x0);
#endif 
}		    




























