#ifndef __LCDD_H
#define __LCDD_H		
#include "sys.h"	 
#include "stdlib.h"
  
//LCDҪ
typedef struct  
{	
	//u8	bus16;				    
	u16 width;			//LCD 
	u16 height;			//LCD ߶
	//u16 id;				//LCD ID
	u8	wramcmd;		//ʼдgramָ
	u8  setxcmd;		//xָ
	u8  setycmd;		//yָ	 
}_lcdd_dev; 	  

//LCD
extern _lcdd_dev lcddev;	//LCDҪ
//LCDĻɫͱɫ	   
extern u16  POINT_COLOR;//ĬϺɫ    
extern u16  BACK_COLOR; //ɫ.ĬΪɫ

//////////////////////////////////////////////////////////////////////////////////	 
//-----------------LCD˿ڶ---------------- 
#define	LCDD_REST PBout(1) //LCD REST    		 PB1 	    
//A18
#define LCDD_REG   (*(volatile uint16_t *)0x6C000000)
#define LCDD_DATA  (*(volatile uint16_t *)0x6C080000)

//////////////////////////////////////////////////////////////////////////////////

//ɫ
#define WHITE         	 0xFFFF
#define BLACK         	 0x0000	  
#define BLUE         	 0x001F  
#define BRED             0XF81F
#define GRED 			 0XFFE0
#define GBLUE			 0X07FF
#define RED           	 0xF800
#define MAGENTA       	 0xF81F
#define GREEN         	 0x07E0
#define CYAN          	 0x7FFF
#define YELLOW        	 0xFFE0
#define BROWN 			 0XBC40 //ɫ
#define BRRED 			 0XFC07 //غɫ
#define GRAY  			 0X8430 //ɫ
//GUIɫ

#define DARKBLUE      	 0X01CF	//ɫ
#define LIGHTBLUE      	 0X7D7C	//ǳɫ  
#define GRAYBLUE       	 0X5458 //ɫ
//ɫΪPANELɫ 
 
#define LIGHTGREEN     	 0X841F //ǳɫ
//#define LIGHTGRAY        0XEF5B //ǳɫ(PANNEL)
#define LGRAY 			 0XC618 //ǳɫ(PANNEL),屳ɫ

#define LGRAYBLUE        0XA651 //ǳɫ(мɫ)
#define LBBLUE           0X2B12 //ǳɫ(ѡĿķɫ)
	    															  
void LCDD_Init_Config(void);													   	//ʼ
void LCDD_DisplayOn(void);													//ʾ
void LCDD_DisplayOff(void);													//ʾ
void LCDD_Clear(u16 Color);	 												//
void LCDD_SetCursor(u16 Xpos, u16 Ypos);										//ù
void LCDD_DrawPoint(u16 x,u16 y);											//
void LCDD_Fast_DrawPoint(u16 x,u16 y,u16 color);								//ٻ
u16  LCDD_ReadPoint(u16 x,u16 y); 											// 
void Draw_Circle(u16 x0,u16 y0,u8 r);										//Բ
void LCDD_DrawLine(u16 x1, u16 y1, u16 x2, u16 y2);							//
void LCDD_DrawRectangle(u16 x1, u16 y1, u16 x2, u16 y2);		   				//
void LCDD_Fill(u16 sx,u16 sy,u16 ex,u16 ey,u16 color);		   				//䵥ɫ
//void LCDD_Color_Fill(u16 sx,u16 sy,u16 ex,u16 ey,u16 *color);				//ָɫ
void LCDD_ShowChar(u16 x,u16 y,u8 num,u8 size,u8 mode);						//ʾһַ
void LCDD_ShowNum(u16 x,u16 y,u32 num,u8 len,u8 size);  						//ʾһ
void LCDD_ShowxNum(u16 x,u16 y,u32 num,u8 len,u8 size,u8 mode);				//ʾ 
void LCDD_ShowString(u16 x,u16 y,u16 width,u16 height,u8 size,u8 *p);		//ʾһַ,12/16
void showhanzi16(unsigned int x,unsigned int y,unsigned char index);	  
void showhanzi32(unsigned int x,unsigned int y,unsigned char index);
void showimage(u16 x,u16 y); //ʾ40*40ͼƬ
void LCDD_WriteReg(u8 LCDD_Reg, u16 LCDD_RegValue);
u16 LCDD_ReadReg(u8 LCDD_Reg);
void LCDD_WriteRAM_Prepare(void);
	  
 
					   																			 
//9320/9325 LCDĴ  
					  		 
#endif  
	 
	 



